"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseComponent = void 0;
const html_node_class_1 = require("./html-node.class");
class BaseComponent {
    constructor(main) {
        this.main = main;
        this.deepSync = false;
        this.main.on("content-init", () => this.check());
    }
    destroy() { }
    ;
    check() {
        const candidate = new html_node_class_1.HTMLNode(this.selector);
        const mustDestroy = (!!this.el && this.deepSync)
            || (!!this.el && this.el.nativeElement !== candidate.nativeElement);
        const mustStart = (!this.el || mustDestroy) && candidate.length > 0;
        if (mustDestroy)
            this.destroy();
        if (mustStart)
            this.start(candidate);
    }
    start(candidate) {
        this.el = candidate;
        this.init();
    }
}
exports.BaseComponent = BaseComponent;
