"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StandardEvents = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
class StandardEvents {
    constructor(main) {
        this.main = main;
        this.main.createEvent("resize", "resize-to-mobile", "resize-to-desktop", "before-unload", "scroll");
        this.onResize$ = (0, rxjs_1.fromEvent)(window, "resize");
        this.beforeUnload$ = (0, rxjs_1.fromEvent)(window, "beforeunload");
        this.onResize$.subscribe(() => this.main.trigger("resize"));
        this.beforeUnload$.subscribe(() => this.main.trigger("before-unload"));
        this.onScroll$ = (0, rxjs_1.merge)((0, rxjs_1.fromEvent)(document.scrollingElement, "wheel")
            .pipe((0, operators_1.map)((e) => ({ delta: e.deltaY }))), (0, rxjs_1.fromEvent)(document.scrollingElement, "touchmove")
            .pipe((0, operators_1.pairwise)(), (0, operators_1.map)(values => {
            const [evt1, evt2] = values;
            return { delta: -evt2.touches[0].clientY + evt1.touches[0].clientY };
        })));
        this.onScroll$.subscribe(e => this.main.trigger("scroll", e));
        this.onResize$
            .pipe((0, operators_1.switchMap)(() => (0, rxjs_1.of)(window.matchMedia("( max-width: 767px )").matches)), (0, operators_1.pairwise)(), (0, operators_1.filter)(values => values[0] !== values[1]))
            .subscribe(() => this.main.trigger("resize-to-mobile"));
        this.onResize$
            .pipe((0, operators_1.switchMap)(() => (0, rxjs_1.of)(window.matchMedia("( min-width: 768px )").matches)), (0, operators_1.pairwise)(), (0, operators_1.filter)(values => values[0] !== values[1]))
            .subscribe(() => this.main.trigger("resize-to-desktop"));
    }
}
exports.StandardEvents = StandardEvents;
