"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Main = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
class Main {
    constructor() {
        this.emitters = {};
        this.createEvent("content-init");
        this.init$ =
            (0, rxjs_1.fromEvent)(window, "load")
                .pipe((0, operators_1.map)(() => true), (0, operators_1.take)(1));
        this.init$.subscribe(() => this.trigger("content-init"));
    }
    createEvent(...args) {
        args.forEach(name => this.emitters[name] = new rxjs_1.Subject());
    }
    on(name, callback) {
        return name.split(" ").map(label => !!this.emitters[label] && this.emitters[label].subscribe((arg) => callback(arg)));
    }
    trigger(evt, arg = true) {
        !!this.emitters[evt] && this.emitters[evt].next(arg);
    }
}
exports.Main = Main;
